for a = 1:1
    SNR = 2*a;                           % Signal to noise ratio.
    for b = 1:1
    % 	Generate random data.
        data = randi([0, mod-1], 10000+n_S, 1);   % Random symbols

    % 	Modulate data.
        txSig = qammod(data, mod);    % Gray encoding?

    % 	Compute linear filter response.
        ChannelResponse = filter(chan, txSig);
        
    % 	Front end noise, as AWGN.
        rxSig = awgn(ChannelResponse,SNR,'measured');
        
    %   Create dfe
        alg = rls(forget);
        equalizerDFE = dfe(m,n,alg,ref);

    %   Equalize signal
        trainlen = n_S;
        [eqSig,detectedSig] = equalize(equalizerDFE,rxSig,txSig(1:trainlen));

    % %   Calculate error
    %     error(:,b) = abs(real(eqSig(1:n_S))-real(txSig(1:n_S)))+abs(imag(eqSig(1:n_S))-imag(txSig(1:n_S)));
    %     plot(error(:,1:b));grid on

    % %   Scatterplot
        h = scatterplot(rxSig,1,trainlen,'bx');
        hold on
        scatterplot(eqSig,1,trainlen,'g.',h);
        scatterplot(equalizerDFE.SigConst,1,0,'m*',h);
        legend('Unfiltered','Filtered',...
           'Reference');
        hold off
    % 
    %   Demodulate signals
        demodSig = qamdemod(rxSig, mod);
        demodEqualizedSig = qamdemod(detectedSig, mod);

    %   Compute the error rates for the two demodulated signals and compare the results.
        nonEqualizedSER(b) = symerr(data(trainlen+1:end), demodSig(trainlen+1:end));
        reset(hErrorCalc)
        equalizedSER(b) = symerr(data(trainlen+1:end), demodEqualizedSig(trainlen+1:end));
    end
    log_SER(1,a) =  mean(nonEqualizedSER*5/n_S);
    log_SER(2,a) =  mean(equalizedSER*5/n_S);
    log_SER(3,a) =  SNR;
end
